test: rtl/help.c File Reference

Main Page | Class Hierarchy | Class List | File List | Class Members | File Members

# help.c File Reference

Go to the source code of this file.

## Functions

BOOL | FIsParentDude (PWND pwnd)
DWORD | GetContextHelpId (PWND pwnd)
BOOL CALLBACK | EnumPwndDlgChildProc (PWND pwnd, LPARAM lParam)

## Function Documentation

BOOL CALLBACK EnumPwndDlgChildProc | ( | PWND | pwnd,
|  | LPARAM | lParam
| ) |

Definition at line 54 of file rtl/help.c.

References BOOL, FIsParentDude(), IsVisible(), PDLGENUMDATA, tagDLGENUMDATA::ptCurHelp, PtInRect(), tagDLGENUMDATA::pwndControl, tagDLGENUMDATA::pwndDialog, and TRUE.

Referenced by EnumHwndDlgChildProc().

    00055 {
    00056     PDLGENUMDATA pDlgEnumData = (PDLGENUMDATA)lParam;
    00057
    00058     if (pwnd != pDlgEnumData->pwndDialog && IsVisible(pwnd) &&
    00059             PtInRect(&((WND *)pwnd)->rcWindow, pDlgEnumData->ptCurHelp)) {
    00060         /*
    00061          * If it's a group box, keep enumerating. This takes care of
    00062          * the case where we have a disabled control in a group box.
    00063          * We'll find the group box first, and keep enumerating until we
    00064          * hit the disabled control.
    00065          */
    00066         pDlgEnumData->pwndControl = pwnd;
    00067         return (FIsParentDude(pwnd));
    00068     }
    00069     return TRUE;
    00070 }

BOOL FIsParentDude | ( | PWND | pwnd | ) |

Definition at line 12 of file rtl/help.c.

References BFTYPEMASK, BOOL, FNID_BUTTON, GETFNID, TestWF, WEFCONTROLPARENT, and WFDIALOGWINDOW.

Referenced by EnumPwndDlgChildProc(), WinHelpA(), and xxxHelpLoop().

    00013 {
    00014     return(TestWF(pwnd, WEFCONTROLPARENT) || TestWF(pwnd, WFDIALOGWINDOW) ||
    00015         ((GETFNID(pwnd) == FNID_BUTTON) &&
    00016          (TestWF(pwnd, BFTYPEMASK) == BS_GROUPBOX)));
    00017 }

DWORD GetContextHelpId | ( | PWND | pwnd | ) |

Definition at line 28 of file rtl/help.c.

References _GetProp(), tagSERVERINFO::atomContextHelpIdProp, DWORD, FNID_DESKTOP, GETFNID, gpsi, MAKEINTATOM, PROPF_INTERNAL, REBASEPWND, and TestwndChild.

Referenced by ComboBoxWndProcWorker(), xxxDefWindowProc(), and xxxHelpLoop().

    00030 {
    00031     DWORD  dwContextId;
    00032
    00033     while (!(dwContextId = (DWORD)(ULONG_PTR)_GetProp(pwnd,
    00034             MAKEINTATOM(gpsi->atomContextHelpIdProp), PROPF_INTERNAL))) {
    00035         pwnd = (TestwndChild(pwnd) ?
    00036                 REBASEPWND(pwnd, spwndParent) :
    00037                 REBASEPWND(pwnd, spwndOwner));
    00038         if (!pwnd || (GETFNID(pwnd) == FNID_DESKTOP))
    00039             break;
    00040     }
    00041
    00042     return dwContextId;
    00043 }